
package de.codedo.conflicteditor.gui;

import java.util.ArrayList;
import java.util.List;

import javax.swing.AbstractListModel;

import org.codehaus.jackson.JsonNode;

public class ConflictsListModel extends AbstractListModel
{
    private List<JsonNode> _conflicts;

    public ConflictsListModel(JsonNode conflictsNode)
    {
        super();
        initConflicts(conflictsNode);
    }

    private void initConflicts(JsonNode conflictsNode)
    {
        _conflicts = new ArrayList<JsonNode>();

        int size = conflictsNode.size();
        for (int i = 0; i < size; i++)
        {
            _conflicts.add(conflictsNode.get(i));
        }
    }

    @Override
    public int getSize()
    {
        return _conflicts.size();
    }

    @Override
    public Object getElementAt(int index)
    {
        return _conflicts.get(index);
    }

    public void remove(JsonNode resolvedConflict)
    {
        int index = findIndex(resolvedConflict);
        if (index > -1)
        {
            _conflicts.remove(index);
            fireContentsChanged(this, index, index);
        }
    }

    private int findIndex(JsonNode node)
    {
        JsonNode id = node.get("_id");
        int index = 0;
        for (JsonNode currentNode : _conflicts)
        {
            JsonNode currentId = currentNode.get("id");
            if (currentId.equals(id))
            {
                return index;
            }
            index++;
        }
        return -1;
    }
}
